#include <extdll.h>

#include <meta_api.h>

extern void PN_UTIL_LogPrintf( char *fmt, ... );

#ifdef _WIN32
//! Required DLL entry point
// necessary for win9x ?
BOOL WINAPI DllMain(
   HINSTANCE hinstDLL,
   DWORD fdwReason,
   LPVOID lpvReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH)
    	{
    		
    	}
	else if (fdwReason == DLL_PROCESS_DETACH)
    	{
    		
    	}
	return TRUE;
}
#endif

//! Holds engine functionality callbacks
enginefuncs_t g_engfuncs;
globalvars_t  *gpGlobals;

extern void MODCheck(void);

// Receive engine function table from engine.
// This appears to be the _first_ DLL routine called by the engine, so we
// do some setup operations here.
C_DLLEXPORT void WINAPI GiveFnptrsToDll( enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals )
{
	memcpy(&g_engfuncs, pengfuncsFromEngine, sizeof(enginefuncs_t));
	gpGlobals = pGlobals;
	// NOTE!  Have to call logging function _after_ copying into g_engfuncs, so
	// that g_engfuncs.pfnAlertMessage() can be resolved properly, heh. :)
	PN_UTIL_LogPrintf("[%s] dev: called: GiveFnptrsToDll\n", Plugin_info.logtag);
	
	MODCheck();
}
